Index: branches/HTM-10.0rc1-dev0/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/Lib/TLibEncoder/TEncSampleAdaptiveOffset.cpp	(revision 837)
@@ -2163,13 +436,13 @@
   while (iterOffset != 0)
   {
-    // Calculate the bits required for signalling the offset
-    tempRate = (typeIdx == SAO_BO) ? (abs((Int)iterOffset)+2) : (abs((Int)iterOffset)+1);
-    if (abs((Int)iterOffset)==offsetTh-1) 
+    // Calculate the bits required for signaling the offset
+    tempRate = (typeIdx == SAO_TYPE_BO) ? (abs((Int)iterOffset)+2) : (abs((Int)iterOffset)+1); 
+    if (abs((Int)iterOffset)==offsetTh) //inclusive 
     {  
       tempRate --;
     }
-    // Do the dequntization before distorion calculation
+    // Do the dequantization before distortion calculation
     tempOffset  = iterOffset << bitIncrease;
-    tempDist    = estSaoDist( count, tempOffset, offsetOrg, shift);
+    tempDist    = estSaoDist( count, tempOffset, diffSum, shift);
     tempCost    = ((Double)tempDist + lambda * (Double) tempRate);
     if(tempCost < tempMinCost)
@@ -2177,9 +450,6 @@
       tempMinCost = tempCost;
       offsetOutput = iterOffset;
-      if(typeIdx == SAO_BO)
-      {
-        currentDistortionTableBo[classIdx-1] = (Int) tempDist;
-        currentRdCostTableBo[classIdx-1] = tempCost;
-      }
+      bestDist = tempDist;
+      bestCost = tempCost;
     }
     iterOffset = (iterOffset > 0) ? (iterOffset-1):(iterOffset+1);
